searchNodes=[{"doc":"PurpleAuthClient Client library for using my password authentication service Purple Auth, available at https://purpleauth.com . Also can be self-hosted. It will handle all the API calls to do the authentication PurpleAuthClient requires configuration values in your application compile environment ( config/config.exs ). :host : The endpoint where Purple Auth is hosted. Probably https://purpleauth.com :app_id : When you create an app at Purple Auth, it will supply you with an App ID . Provide that here. :api_key : You will also be given an API Key to authorize you and prevent others from using your quota. Be sure not to commit this to source control.","ref":"PurpleAuthClient.html","title":"PurpleAuthClient","type":"module"},{"doc":"Request a new ID token using a refresh token. Returns a new id token Parameters refresh_token: Refresh token from the client. Examples &gt; PurpleAuthClient . refresh ( &quot;refresh_token&quot; ) { :ok , &quot;newidtokenfromserver&quot; } &gt; PurpleAuthClient . refresh ( &quot;invalid_refresh_token&quot; ) { :error , :authentication_failure }","ref":"PurpleAuthClient.html#refresh/1","title":"PurpleAuthClient.refresh/1","type":"function"},{"doc":"Starts authenticating a user by sending information to their email using the given flow Parameters email: the email of the user to be authenticated flow: either :magic for a magic link the redirects back to your site or :otp to send the user a code they can enter within a certain time. Returns :ok or a tuple of :error and information about the error Examples &gt; PurpleAuthClient . start_authentication ( &quot;rickhenry@rickhenry.dev&quot; , :otp ) :ok &gt; PurpleAuthClient . start_authentication ( &quot;rickhenry@rickhenry.dev&quot; , :magic ) :ok &gt; PurpleAuthClient . start_authentication ( &quot;bad email&quot; , :otp ) { :error , :validation_error }","ref":"PurpleAuthClient.html#start_authentication/2","title":"PurpleAuthClient.start_authentication/2","type":"function"},{"doc":"Submits the one time password provided by a user. Returns either the new authentication tokens or and error and a reason. Parameters email: The user's email code: code entered by the user based on what they received in their email Examples &gt; PurpleAuthClient . submit_code ( &quot;rickhenry@rickhenry.dev&quot; , &quot;123456&quot; ) { :ok , %{ &quot;id_token&quot; =&gt; &quot;newjwtidtoken&quot; } } &gt; PurpleAuthClient . submit_code ( &quot;rickhenry@rickhenry.dev&quot; , &quot;123457&quot; ) { :error , :authentication_failure }","ref":"PurpleAuthClient.html#submit_code/2","title":"PurpleAuthClient.submit_code/2","type":"function"},{"doc":"Verify an ID Token locally from your server. This will be much faster because we cache the public keys so that after the first time, it can be executed without any slow REST API calls. Returns :ok and the claims from the token or :error and information about the error. Parameters id_token: the token to verify Examples &gt; PurpleAuthClient . verify ( &quot;useridtoken&quot; ) { :ok , %{ &quot;iat&quot; =&gt; 123456 , &quot;sub&quot; =&gt; &quot;rickhenry@rickhenry.dev&quot; } } &gt; PurpleAuthClient . verify ( &quot;fakeuseridtoken&quot; ) { :error , :signature_error }","ref":"PurpleAuthClient.html#verify/1","title":"PurpleAuthClient.verify/1","type":"function"},{"doc":"Request the server to do token verification. Returns :ok and claims from the token or :error and a reason. Parameters id_token: JWT idToken from the client Examples &gt; PurpleAuthClient . verify_token_remote ( &quot;some_id_token&quot; ) { :ok , %{ &quot;sub&quot; =&gt; &quot;rickhenry@rickhenry.dev&quot; } } &gt; PurpleAuthClient . verify_token_remote ( &quot;expired_token&quot; ) { :error , :authentication_failure }","ref":"PurpleAuthClient.html#verify_token_remote/1","title":"PurpleAuthClient.verify_token_remote/1","type":"function"},{"doc":"An Elixir client for my Purple Auth microservice.","ref":"readme.html","title":"PurpleAuthClient","type":"extras"},{"doc":"# config/config.exs import Config config :purple_auth_client , host : &quot;http://purpleauth.com&quot; , # or wherever you&#39;re hosting it app_id : &quot;[app id obtained from purple auth portal]&quot; , api_key : &quot;[api key obtained from purple auth portal]&quot;","ref":"readme.html#configuration","title":"PurpleAuthClient - Configuration","type":"extras"},{"doc":"/otp/request/ Start otp authentication flow with server. &gt; PurpleAuthClient . start_authentication ( &quot;rickhenry@rickhenry.dev&quot; , :otp ) :ok /magic/request/ &gt; PurpleAuthClient . start_authentication ( &quot;rickhenry@rickhenry.dev&quot; , :magic ) :ok /otp/confirm/ Complete authentication with email and generated code. &gt; PurpleAuthClient . submit_code ( &quot;rickhenry@rickhenry.dev&quot; , &quot;123456&quot; ) { :ok , %{ id_token : &quot;tokenfromserver&quot; , refresh_token : &quot;refreshtokenfromserver&quot; } } /token/verify/ Send idToken to server for verification. This is not recommended as local verification will be significantly faster after the first time. &gt; PurpleAuthClient . verify_token_remote ( &quot;idtoken&quot; ) { :ok , claims } /token/refresh/ Request a new ID Token from the server using a refresh token &gt; PurpleAuthClient . refresh ( &quot;refreshtoken&quot; ) { :ok , &quot;newidtoken&quot; }","ref":"readme.html#routes-covered","title":"PurpleAuthClient - Routes Covered","type":"extras"},{"doc":"Verify and decode an ID Token on directly in the app without having to call out every time. It's much faster because the keys are cached in an :ets table &gt; PurpleAuthClient . verify ( &quot;idtoken&quot; ) { :ok , claims } &gt; PurpleAuthClient . verify ( &quot;invalididtoken&quot; ) { :error , :signature_error }","ref":"readme.html#local-verification","title":"PurpleAuthClient - Local Verification","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding purple_auth_client to your list of dependencies in mix.exs : def deps do [ { :purple_auth_client , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"PurpleAuthClient - Installation","type":"extras"},{"doc":"MIT License Copyright (c) 2022 Rick Henry Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]